
//@vs
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

void main () 
{	
	float4 lP = POS0;

	//
#ifdef sd_DetailU

	float tx, ty, tz;
	float rot_Ta, rot_Tb, rot_T;

	/*----------------------------------- 
		rotate axis (Y),,, Pitch
								{	cos,	0,		-sin	}
		V(x,y,z) * M{	0,		1,		0			}
								{	sin,	0,		cos		}
	*/
	tx = lP.x;		
	tz = lP.z;
	
	rot_Ta = BendPitchHeadTheta * -saturate (tx);				//head	(up:+, down:-)
	rot_Tb = BendPitchTailTheta * saturate (-tx);				//tail 	(up:+, down:-)
	rot_T = rot_Ta + rot_Tb;

	lP.x =  tx * cos(rot_T)  +  tz * sin(rot_T);
	lP.z = -tx * sin(rot_T)  +  tz * cos(rot_T);


	/*----------------------------------- 
		rotate axis (X),,, Roll 
								{	1,		0,		0			}
		V(x,y,z) * M{	0,		cos,	sin		}
								{	0,		-sin,	cos		}
	*/
	ty = lP.y;		
	tz = lP.z;

	rot_T = BendRollTheta * (ty);				//head	(up:+, down:-)

	lP.y = ty * cos(rot_T)  -  tz * sin(rot_T);
	lP.z = ty * sin(rot_T)  +  tz * cos(rot_T);

	/*----------------------------------- 
		rotate axis (Z),,, Yaw
								{ cos,	sin,	0		}
		V(x,y,z) * M{	-sin,	cos,	0		}
								{	0,		0,		0		}
	*/

	tx = lP.x;		
	ty = lP.y;

	rot_T = BendYawHeadTheta * saturate(tx);				//head	(up:+, down:-)

	lP.x = tx * cos(rot_T)  +  ty * sin(rot_T);
	lP.y = tx * -sin(rot_T) +  ty * cos(rot_T);

#endif
	//

	float3 wP = (matW * lP).xyz;
	float3 wN = normalize(matW * float4(NOR0.xyz, 0.0)).xyz;
	float3 wE = normalize (EyePos - wP.xyz).xyz;
	
	float3 ambc			= float3 (Ambient, Ambient, Ambient);
	float sun_diff	= calc_diffuse (SunDir, wN, LambertPow);
	float sun_spec	= calc_specular (SunDir, wN, wE, SpecIntensity*SpecRatio, SpecPow);
	float rim_diff	= calc_rimlight (SunDir, wN, wE, RimIntensity, RimBand);

	float3 diff = ambc.xyz + (sun_diff + sun_spec) * SunColor + float3(rim_diff, rim_diff, rim_diff);
	//diff += (LightColor.xyz * 5.0 * LitIntensity);
	//diff += (CLR0.xyz * 5.0 * LitIntensity);

	vs_out_p = matVP * float4 (wP.xyz, 1.0);
	vs_out_1 = float4 (TUV0.xy, 0.0, 0.0);
	vs_out_0 = float4 (diff*UserColor.xyz, UserColor.w);

#ifdef sd_DetailU
	vs_out_1.zw = float2 (wP.xy*0.01);
	vs_out_2 = float4 (reflect(-wE.xzy, wN.xzy), ReflRatio);
#endif

}

#endif



//@ps
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

	#define ColorKey		0.03
	#define DiffColor		ps_in_0.xyzw
	#define TexUV				ps_in_1.xy
	#define TexUV1			ps_in_1.zw
	#define ReflUV			ps_in_2.xyz
	#define ReflRat			ps_in_2.w

void main () 
{ 
#ifdef sd_Detail
	ps_out_c = texture2D (c_samp0, TexUV ) * DiffColor;
#endif

#ifdef sd_DetailU

	float4 texD = texture2D (c_samp0, TexUV ).xyzw;	 
	float4 Cloud = texture2D (c_samp1, TexUV1 ).xyzw;	 
	
	texD.xyz = lerp (texD.xyz, texD.xyz*Cloud.x, 0.15);
	
	float4 texR = textureCB (c_cube,  ReflUV ).xyzw;	 
	texD.xyz = lerp (texD.xyz, texD.xyz+texR.xyz, ReflRat*texD.w);

	ps_out_c = float4 (texD.xyz*DiffColor.xyz, texD.w*DiffColor.w);

#endif

#ifdef sd_General
	ps_out_c = texture2D (c_samp0, TexUV ) * DiffColor;
#endif

}

#endif







