
//@vs
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

void main () 
{	
	float4 lP = POS0;

	float3 wP = (matW * lP).xyz;
	float3 wN = normalize(matW * float4(NOR0.xyz, 0.0)).xyz;
	
	float3 ambc = float3 (Ambient, Ambient, Ambient);
	float sun_diff = calc_diffuse (SunDir, wN, LambertPow);

	float3 wE = normalize (EyePos - wP.xyz).xyz;
	float sun_spec = calc_specular (SunDir, wN, wE, SpecIntensity*SpecRatio, SpecPow);
	float rim_diff = calc_rimlight (SunDir, wN, wE, RimIntensity, RimBand);

	//float3 diff = ambc.xyz + (sun_diff + sun_spec) * SunColor + float3(rim_diff, rim_diff, rim_diff);
	float3 diff = ambc.xyz + (sun_diff) * SunColor + float3(rim_diff, rim_diff, rim_diff);

	//diff += (LightColor.xyz * 5.0 * LitIntensity);
	//diff += (CLR0.xyz * 5.0);

	vs_out_p = matVP * float4 (wP.xyz, 1.0);
	vs_out_0 = float4 (diff*UserColor.xyz, UserColor.w);
	vs_out_1 = float4 (TUV0.xy, TUV1.xy);
	vs_out_2 = float4 (reflect(-wE.xzy, wN.xzy), ReflRatio);
	vs_out_3 = float4 (SunColor, sun_spec);
}

#endif



//@ps
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

	#define DiffColor		ps_in_0.xyzw
	#define TexUV				ps_in_1.xy
	#define TexUV1			ps_in_1.zw
	#define ReflUV			ps_in_2.xyz
	#define inSpecColor		ps_in_3.xyz
	#define inSpecRatio		ps_in_3.w

void main () 
{ 
	float4 texD = texture2D (c_samp0, TexUV );
	float4 clrD = texture2D (c_samp1, TexUV1 );
	float4 texR = textureCB (c_cube,  ReflUV ).xyzw;	 

	texD.xyz = lerp (texD.xyz, texD.xyz+texR.xyz, ReflRatio*texD.w);

	texD.xyz *= clrD.w;
	texD.xyz += clrD.xyz;
	texD.xyz += (inSpecColor * inSpecRatio * texD.w);

	ps_out_c = float4 (texD.xyz * DiffColor.xyz,  1.0);

	//float4 texD = texture2D (c_samp0, TexUV ).xyzw;	 
	//float4 texR = textureCB (c_cube,  ReflUV ).xyzw;	 
	//float3 rcolor = lerp (texD.xyz, texD.xyz+texR.xyz, ReflRatio*texD.w);
	//ps_out_c = float4 (rcolor.xyz*DiffColor.xyz, texD.w*DiffColor.w);

}

#endif







