//v0: xyzw:WorldPos
//v1: xy:NormalUV, zw:MaskUV
//v2: xyzw:ScreenPos

//@vs
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

void main () 
{	
	float3 wP = (matW * POS0).xyz;					//world pos
	float dist = calc_distance (EyePos, wP);
	float fog = get_dis_alpha (dist, FogNear, FogFar);
	float3 diff;

#ifdef sd_General
	 diff = SandColor;
#endif

#ifdef sd_SandPatch
	 diff = NOR0.xyz;
#endif

	vs_out_p = (matVP * float4(wP, 1.0));	//screen pos
	vs_out_0 = float4 (diff, fog);
	vs_out_1.xy = (wP.xy / 100.0) * UV0Mul;
	//vs_out_1.z = 1.0 - get_dis_alpha (dist, 200.0, 1000.0);
}

#endif


//@ps
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

#define DiffColor				ps_in_0
#define TileUV					ps_in_1.xy
//#define SandRatio				ps_in_1.z

void main () 
{ 
	//float4 texD0 = texture2D (c_samp0, TileUV);
	//float4 texD1 = texture2D (c_samp0, TileUV*0.1);
	//ps_out_c = float4 (lerp (texD0.xyz, texD1.xyz, SandRatio)*DiffColor.xyz, DiffColor.w);

	ps_out_c = float4 (texture2D (c_samp0, TileUV).xyz*DiffColor.xyz, DiffColor.w);
}

#endif






