//@vs
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

	#define _CTIME_SEC_		c_parm0.w

	void main () 
	{	
		float3 wP = (matW * POS0).xyz;
		float dist = calc_distance (EyePos, wP.xyz);
		float fog = get_dis_alpha (dist, FogNear, FogFar);

		//float3 diff = float3(Ambient, Ambient, Ambient) + (SunColor * CLR1.w) + (ShwColor.xyz * ShwColor.w * pow((1.0 - CLR1.w), 1.0));
		//diff += (CLR1.xyz * 5.0 * LitIntensity);
		//diff *= (CLR0.xyz);// * 5.0);
		float3 diff = NOR0.xyz;

		vs_out_p = matVP * float4 (wP.xyz, 1.0);
		vs_out_0 = float4 (diff.xyz, fog);

#ifdef sd_TerrPlane
		vs_out_1.xy = (wP.xy/64.0)*LayerUVR;
		vs_out_1.zw = TUV0.xy;
#endif

#ifdef sd_TerrGeneral
		vs_out_1.xy = TUV0.xy*LayerUVR;
#endif

	}

#endif


//@ps
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

	#define DiffColor				ps_in_0
	#define TileUV					ps_in_1.xy
	#define Splat						ps_in_1.z
	#define Splat1					ps_in_1.w

	void main () 
	{ 
#ifdef sd_TerrPlane
		float4 texD0 = texture2D (c_samp0, TileUV);
		float4 texD1 = texture2D (c_samp1, TileUV);
		float4 texD = lerp (texD0, texD1, Splat);
		ps_out_c = float4 (texD.xyz*DiffColor.xyz, DiffColor.w);
#endif

#ifdef sd_TerrGeneral
	ps_out_c = texture2D (c_samp0, TileUV) * DiffColor;
#endif

	}

#endif













